searchNodes=[{"ref":"AuthN.AuthenticationPlugMixin.html","title":"AuthN.AuthenticationPlugMixin","type":"behaviour","doc":"Allows to create a plug enforcing authentication for private routes. A user-defined module must use this module, making the user module a plug, and implement the handle_authentication_error/2 behaviour. The handle_authentication_error/2 callback receives a Plug.Conn struct and an atom identifying the set of routes that require authentication, and must return a Plug.Conn struct. Example: defmodule MyAppWeb.Plugs.EnsureAuthenticated do use AuthN.AuthenticationPlugMixin import Plug.Conn import Phoenix.Controller def handle_authentication_error(conn, :admin_routes), do: conn |&gt; put_status(401) |&gt; text(&quot;unauthenticated&quot;) |&gt; halt() end EnsureAuthenticated is now a plug which can be used in the router: pipeline :ensure_admin_routes_authorized do plug MyAppWeb.Plugs.EnsureAuthenticated, resource: :admin_routes end scope &quot;/admin&quot;, MyAppWeb, as: :admin do pipe_through [:browser, :ensure_admin_routes_authorized] # code end"},{"ref":"AuthN.AuthenticationPlugMixin.html#c:handle_authentication_error/2","title":"AuthN.AuthenticationPlugMixin.handle_authentication_error/2","type":"callback","doc":""},{"ref":"AuthN.Authenticator.DBAuthenticator.html","title":"AuthN.Authenticator.DBAuthenticator","type":"module","doc":""},{"ref":"AuthN.Authenticator.DBAuthenticator.html#authenticate/4","title":"AuthN.Authenticator.DBAuthenticator.authenticate/4","type":"function","doc":"Authenticates a user&#39;s credentials against a given repository and schema. The given schema must implement the AuthN.Ecto.AuthNFields behaviour, which allows this function to retrieve the identifier and password schema field names. By default, this function uses the Argon2 password-hashing function from the argon2_elixir library. The default may be replaced by passing a module name to the :hashing_module option that implements the Comeonin and Comeonin.PasswordHash behaviours from the comeonin library, such as Bcrypt from the bcrypt_elixir library. Returns the tuple {:ok, user} in case of successful authentication (where user is the struct fetched from the data store that aligns with the given credentials), {:error, :unknown_user} in case the given identifier is not found in the data store, and {:error, :wrong_password} in case the given password doesn&#39;t match the one found in the data store."},{"ref":"AuthN.Ecto.AuthNFields.html","title":"AuthN.Ecto.AuthNFields","type":"behaviour","doc":"Provides macros for defining the fields that are used for user accounts&#39; credentials. identifier_field/1 defines the field storing the login name (usually the user&#39;s email or username) and password_field/1 defines the field storing the hashed password."},{"ref":"AuthN.Ecto.AuthNFields.html#c:get_identifier_field/0","title":"AuthN.Ecto.AuthNFields.get_identifier_field/0","type":"callback","doc":""},{"ref":"AuthN.Ecto.AuthNFields.html#c:get_password_field/0","title":"AuthN.Ecto.AuthNFields.get_password_field/0","type":"callback","doc":""},{"ref":"AuthN.Ecto.AuthNFields.html#identifier_field/1","title":"AuthN.Ecto.AuthNFields.identifier_field/1","type":"macro","doc":"Defines which field stores the user&#39;s login (usually an email or username)."},{"ref":"AuthN.Ecto.AuthNFields.html#password_field/1","title":"AuthN.Ecto.AuthNFields.password_field/1","type":"macro","doc":"Defines which field is used for the user&#39;s password."},{"ref":"AuthN.HTML.AuthNHelpers.html","title":"AuthN.HTML.AuthNHelpers","type":"module","doc":""},{"ref":"AuthN.HTML.AuthNHelpers.html#authenticated?/1","title":"AuthN.HTML.AuthNHelpers.authenticated?/1","type":"function","doc":"View helper allowing to check whether the current user is authenticated or not."},{"ref":"AuthN.HTML.AuthNHelpers.html#current_user/1","title":"AuthN.HTML.AuthNHelpers.current_user/1","type":"function","doc":"View helper returning the current user or nil in case the current user is not authenticated."},{"ref":"AuthN.Plugs.AssignCurrentUser.html","title":"AuthN.Plugs.AssignCurrentUser","type":"module","doc":"This plug fetches the current user by the user ID stored in session and stores the fetched user in conn.assigns. The user is fetched by a function provided through the mandatory :fetch_user option; the function receives the user ID as argument. In case no user ID is stored in session, this plug does nothing (just returns the conn received). In case a user ID is stored in session, but no user can be found for that ID, the plug clears the session."},{"ref":"AuthN.Plugs.AssignCurrentUser.html#call/2","title":"AuthN.Plugs.AssignCurrentUser.call/2","type":"function","doc":""},{"ref":"AuthN.Plugs.AssignCurrentUser.html#init/1","title":"AuthN.Plugs.AssignCurrentUser.init/1","type":"function","doc":""},{"ref":"AuthN.Plugs.SetSessionStorage.html","title":"AuthN.Plugs.SetSessionStorage","type":"module","doc":"This plug allows to change the storage mechanism for sessions. By default, the session is stored into a stateless cookie."},{"ref":"AuthN.Plugs.SetSessionStorage.html#call/2","title":"AuthN.Plugs.SetSessionStorage.call/2","type":"function","doc":""},{"ref":"AuthN.Plugs.SetSessionStorage.html#init/1","title":"AuthN.Plugs.SetSessionStorage.init/1","type":"function","doc":""},{"ref":"AuthN.SessionStorage.html","title":"AuthN.SessionStorage","type":"behaviour","doc":"Module used for storing, retrieving and deleting the user ID into/from the session. This module serves as an interface, delegating calls to another module implementing the session&#39;s storage logic. The default implementation module is AuthN.SessionStorage.StatelessCookie, which stores sessions into stateless cookies. Another module implementing sessions storage can be specified by adding the module name into the :session_storage key of conn.private."},{"ref":"AuthN.SessionStorage.html#delete_user_id/1","title":"AuthN.SessionStorage.delete_user_id/1","type":"function","doc":""},{"ref":"AuthN.SessionStorage.html#c:delete_user_id/1","title":"AuthN.SessionStorage.delete_user_id/1","type":"callback","doc":""},{"ref":"AuthN.SessionStorage.html#get_user_id/1","title":"AuthN.SessionStorage.get_user_id/1","type":"function","doc":""},{"ref":"AuthN.SessionStorage.html#c:get_user_id/1","title":"AuthN.SessionStorage.get_user_id/1","type":"callback","doc":""},{"ref":"AuthN.SessionStorage.html#put_user_id/2","title":"AuthN.SessionStorage.put_user_id/2","type":"function","doc":""},{"ref":"AuthN.SessionStorage.html#c:put_user_id/2","title":"AuthN.SessionStorage.put_user_id/2","type":"callback","doc":""},{"ref":"AuthN.SessionStorage.html#t:conn/0","title":"AuthN.SessionStorage.conn/0","type":"type","doc":""},{"ref":"AuthN.SessionStorage.AssignsMap.html","title":"AuthN.SessionStorage.AssignsMap","type":"module","doc":"Module for storing sessions into conn.private. Used for testing."},{"ref":"AuthN.SessionStorage.AssignsMap.html#delete_user_id/1","title":"AuthN.SessionStorage.AssignsMap.delete_user_id/1","type":"function","doc":"Callback implementation for AuthN.SessionStorage.delete_user_id/1."},{"ref":"AuthN.SessionStorage.AssignsMap.html#get_user_id/1","title":"AuthN.SessionStorage.AssignsMap.get_user_id/1","type":"function","doc":"Callback implementation for AuthN.SessionStorage.get_user_id/1."},{"ref":"AuthN.SessionStorage.AssignsMap.html#put_user_id/2","title":"AuthN.SessionStorage.AssignsMap.put_user_id/2","type":"function","doc":"Callback implementation for AuthN.SessionStorage.put_user_id/2."},{"ref":"AuthN.SessionStorage.AssignsMap.html#t:conn/0","title":"AuthN.SessionStorage.AssignsMap.conn/0","type":"type","doc":""},{"ref":"AuthN.SessionStorage.StatelessCookie.html","title":"AuthN.SessionStorage.StatelessCookie","type":"module","doc":"Module for storing sessions into stateless cookies. This is the library&#39;s default storage mechanism for storing sessions."},{"ref":"AuthN.SessionStorage.StatelessCookie.html#delete_user_id/1","title":"AuthN.SessionStorage.StatelessCookie.delete_user_id/1","type":"function","doc":"Callback implementation for AuthN.SessionStorage.delete_user_id/1."},{"ref":"AuthN.SessionStorage.StatelessCookie.html#get_user_id/1","title":"AuthN.SessionStorage.StatelessCookie.get_user_id/1","type":"function","doc":"Callback implementation for AuthN.SessionStorage.get_user_id/1."},{"ref":"AuthN.SessionStorage.StatelessCookie.html#put_user_id/2","title":"AuthN.SessionStorage.StatelessCookie.put_user_id/2","type":"function","doc":"Callback implementation for AuthN.SessionStorage.put_user_id/2."},{"ref":"AuthN.SessionStorage.StatelessCookie.html#t:conn/0","title":"AuthN.SessionStorage.StatelessCookie.conn/0","type":"type","doc":""},{"ref":"readme.html","title":"AuthN","type":"extras","doc":"AuthN AuthN is a simple authentication library that allows you to authenticate a user against a database; maintain the user logged in; ensure private routes are accessed by logged in users only; use view helpers to access the logged in user from templates."},{"ref":"readme.html#authenticate-the-user","title":"AuthN - Authenticate the user","type":"extras","doc":"In your Schema representing the user accounts, specify which are the username and password fields using the identifier_field/1 and password_field/1 macros: use AuthN.Ecto.AuthNFields schema &quot;users&quot; do identifier_field :email password_field :password_hash field :name, :string field :active, :boolean end DBAuthenticator.authenticate/3 allows you to authenticate the user against the database. The first two arguments are the username and password, and the third argument is a tuple containing your Repo module name and the user account Schema struct. This function is typically called in the controller action handling login submissions; the email and password being provided by the user through a login form. alias AuthN.Authenticator.DBAuthenticator case DBAuthenticator.authenticate(email, password, {MyApp.Repo, MyApp.Accounts.User}) do {:ok, user} -&gt; conn |&gt; put_flash(:info, &quot;Welcome back!&quot;) |&gt; redirect(to: Routes.profile_path(conn, :index)) {:error, :unknown_user} -&gt; conn |&gt; put_flash(:error, &quot;No account found with that email address.&quot;) |&gt; render(&quot;new.html&quot;) {:error, :wrong_password} -&gt; conn |&gt; put_flash(:error, &quot;Invalid password&quot;) |&gt; render(&quot;new.html&quot;) end By default, the library will use the Argon2 hash function to verify passwords. Argon2 is recommended over bcrypt.See argon2_elixir. You may change the default password-hashing function through the :hashing_module option, by passing it a module name which implements the Comeonin and Comeonin.PasswordHash behaviours from the comeonin library, such as bcrypt_elixir. In most situations you do not want to reveal if the account exists in case of a failed authentication: case DBAuthenticator.authenticate(email, password, {MyApp.Repo, MyApp.Accounts.User}) do {:ok, user} -&gt; conn |&gt; put_flash(:info, &quot;Welcome back!&quot;) |&gt; redirect(to: Routes.admin_question_path(conn, :index)) _ -&gt; conn |&gt; put_flash(:error, &quot;Invalid username/password combination&quot;) |&gt; render(&quot;new.html&quot;) end Rather than calling DBAuthenticator.authenticate/3 from the controller, one can instead call it from the context. Not only this is cleaner as the Repo should preferably only be known by the context, but one can also add additional application-specific authentication logic such as verifying if the user account has been locked: def authenticate(email, password) do case DBAuthenticator.authenticate(email, password, {Repo, User}) do {:ok, %{:active =&gt; true} = user} -&gt; {:ok, user} {:ok, _} -&gt; {:error, :inactive_user} error -&gt; error end end"},{"ref":"readme.html#maintain-the-user-logged-in","title":"AuthN - Maintain the user logged in","type":"extras","doc":"After a successful authentication, the user ID should be stored into session in order to identify the logged user on subsequent requests. SessionStorage.put_user_id/1 stores the user ID into the session. alias AuthN.SessionStorage case DBAuthenticator.authenticate(email, password, {MyApp.Repo, MyApp.Accounts.User}) do {:ok, user} -&gt; conn |&gt; SessionStorage.put_user_id(user.id) |&gt; put_flash(:info, &quot;Welcome back!&quot;) |&gt; redirect(to: Routes.profile_path(conn, :index)) # code end Note: By default, the session is stored in a stateless cookie. The library uses the functions from Plug to handle data in session, such as Plug.Conn.put_session/2, Plug.Conn.get_session/2, Plug.Conn.configure_session/1, ... Once the user ID has been stored into the session, the user can be retrieved by the AuthN.Plugs.AssignCurrentUser plug: pipeline :browser do plug :accepts, [&quot;html&quot;] plug :fetch_session plug :fetch_flash plug :protect_from_forgery plug :put_secure_browser_headers plug AuthN.Plugs.AssignCurrentUser, fetch_user: &amp;MyApp.Accounts.get_user/1 end The AssignCurrentUser plug stores the logged in user into conn.assigns under the :current_user key. The user is fetched by a user-defined function provided to the plug, through the :fetch_user option, and receiving the user ID as argument."},{"ref":"readme.html#protecting-routes-against-unauthenticated-users","title":"AuthN - Protecting routes against unauthenticated users","type":"extras","doc":"Authentication can be enforced for some routes. Create a module using (use) the AuthN.AuthenticationPlugMixin module; then implement the callback handle_authentication_error/2 receiving a Plug.Conn struct and an atom identifying the set of routes that require authentication: defmodule MyAppWeb.Plugs.EnsureAuthenticated do use AuthN.AuthenticationPlugMixin import Plug.Conn import Phoenix.Controller def handle_authentication_error(conn, :admin_routes), do: conn |&gt; put_status(401) |&gt; text(&quot;unauthenticated&quot;) |&gt; halt() end You may then use the new plug into a pipeline and ensure that routes requiring authentication are accessed by logged in users only. pipeline :ensure_admin_routes_authorized do plug MyAppWeb.Plugs.EnsureAuthenticated, resource: :admin_routes end scope &quot;/admin&quot;, MyAppWeb, as: :admin do pipe_through [:browser, :ensure_admin_routes_authorized] # code end"},{"ref":"readme.html#installation","title":"AuthN - Installation","type":"extras","doc":"Add auth_n for Elixir as a dependency in your mix.exs file: def deps do [ {:auth_n, &quot;~&gt; 0.3.0&quot;} ] end"},{"ref":"readme.html#hexdocs","title":"AuthN - HexDocs","type":"extras","doc":"HexDocs documentation can be found at https://hexdocs.pm/auth_n."}]